import 'package:flutter/material.dart';
import 'package:bmi_global/layout/route.dart';

class ConfigProvider with ChangeNotifier {
  ThemeMode _themeMode;
  final void Function(ThemeMode) _onThemeChange;
  final Widget Function(BuildContext) build404Page;
  final AppRoute defaultRoute;
  final Widget Function(BuildContext, Widget) finalGateway;

  ConfigProvider(
    this._themeMode,
    this._onThemeChange, {
    required this.build404Page,
    required this.defaultRoute,
    required this.finalGateway,
  });

  ThemeMode get themeMode => _themeMode;

  void onThemeModeChange(ThemeMode? newMode) {
    if (newMode == null) return;
    _themeMode = newMode;
    _onThemeChange(_themeMode);
    notifyListeners();
  }
}
