import 'package:bmi_global/utils/parsers.dart';

class Version {
  final int v1;
  final int v2;
  final int v3;
  final int buildNum;
  Version(List<String> versionNameInList, String buildVersion)
      : buildNum = toInt(buildVersion),
        v1 = toInt(versionNameInList[0]),
        v2 = toInt(versionNameInList[1]),
        v3 = toInt(versionNameInList[2]);

  bool operator >(Version version) {
    return hashCode > version.hashCode;
  }

  bool operator <(Version version) {
    return hashCode < version.hashCode;
  }

  @override
  bool operator ==(dynamic other) {
    return other is Version && hashCode == other.hashCode;
  }

  @override
  String toString() {
    return "$v1.$v2.$v3+$buildNum";
  }

  @override
  int get hashCode => v1 * 1000000 + v2 * 10000 + v3 * 100 + buildNum;
}

class AppInfoDoc {
  final String description;
  final String iconImage;
  final String image;
  final String title;
  final Version version;
  AppInfoDoc.fromJson(RawMap data)
      : description = data["description"].toString(),
        iconImage = data["icon"].toString(),
        image = data["image"].toString(),
        title = data["title"].toString(),
        version = Version(
          data["versionName"].toString().split("."),
          data["version"].toString(),
        );
}
